"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var socketIOClient = require("socket.io-client");
var LiveReloadClient = (function () {
    function LiveReloadClient(settings) {
        var _this = this;
        this.fetchOptions = {
            method: 'GET',
            credentials: 'same-origin',
            headers: {
                accept: 'application/json;odata=verbose'
            }
        };
        this.init = function () {
            var pageResources = [];
            var pageStyles = [];
            var socket = socketIOClient.connect(_this.devBaseUrl, {
                reconnectionDelay: 1000,
                reconnection: true,
                reconnectionAttempts: 25,
                transports: ['websocket'],
                agent: false,
                upgrade: false,
                rejectUnauthorized: false
            });
            _this.getPageResources().then(function (res) {
                pageResources = res;
            });
            var styles = Array.prototype.slice.call(document.getElementsByTagName('link'));
            pageStyles = styles
                .filter(function (s) { return s.href.length > 0; });
            socket.on('live_reload', function (data) {
                var mapRegexp = /\.map$/i;
                var filePath = (data.filePath || '').split('?')[0].toLowerCase();
                filePath = filePath.replace(mapRegexp, '');
                if (pageResources.indexOf(filePath) !== -1) {
                    if (filePath.indexOf('.css') !== -1) {
                        pageStyles.forEach(function (s) {
                            var hostname = location.href.split('/').splice(0, 3).join('/');
                            var resourceUrl = s.href.split('?')[0].replace(hostname, '');
                            if (resourceUrl.toLowerCase() === filePath) {
                                if (typeof data.body === 'undefined' || data.body === null) {
                                    var href = resourceUrl + "?ver=" + (new Date()).getTime();
                                    s.href = href;
                                }
                                else {
                                    var styleElement = document.getElementById(resourceUrl);
                                    if (styleElement === null) {
                                        styleElement = document.createElement('style');
                                        styleElement.id = resourceUrl;
                                        styleElement.setAttribute('type', 'text/css');
                                        styleElement.innerHTML = data.body;
                                        s.after(styleElement);
                                        s.remove();
                                    }
                                    else {
                                        styleElement.innerHTML = data.body;
                                        s.remove();
                                    }
                                }
                            }
                        });
                    }
                    else {
                        window.location.reload();
                    }
                }
            });
            socket.on('reconnect_attempt', function () {
                socket.io.opts.transports = ['polling', 'websocket'];
            });
        };
        this.getPageResources = function () { return __awaiter(_this, void 0, void 0, function () {
            var contentLinks, endpoint, basePath, scripts, styles;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contentLinks = [];
                        basePath = window.location.protocol + "//" + window.location.hostname;
                        scripts = Array.prototype.slice.call(document.getElementsByTagName('script'));
                        contentLinks = contentLinks.concat(scripts
                            .filter(function (s) { return s.src.length > 0; })
                            .map(function (s) {
                            return decodeURIComponent(s.src.replace(basePath, '').split('?')[0].toLowerCase());
                        }));
                        styles = Array.prototype.slice.call(document.getElementsByTagName('link'));
                        contentLinks = contentLinks.concat(styles
                            .filter(function (s) { return s.href.length > 0; })
                            .map(function (s) {
                            return decodeURIComponent(s.href.replace(basePath, '').split('?')[0].toLowerCase());
                        }));
                        endpoint = this.webUrl + "_api/web?$select=MasterUrl";
                        return [4, fetch(endpoint, this.fetchOptions)
                                .then(function (r) { return r.json(); })
                                .then(function (_a) {
                                var res = _a.d;
                                contentLinks.push(res.MasterUrl.split('?')[0].toLowerCase());
                            })];
                    case 1:
                        _a.sent();
                        if (!(_spPageContextInfo && _spPageContextInfo.pageListId && _spPageContextInfo.pageItemId)) return [3, 3];
                        endpoint = this.webUrl + "_api/web/lists('" + _spPageContextInfo.pageListId + "')/items(" + _spPageContextInfo.pageItemId + ")";
                        return [4, fetch(endpoint, this.fetchOptions)
                                .then(function (r) { return r.json(); })
                                .then(function (_a) {
                                var res = _a.d;
                                if (res.PublishingPageLayout) {
                                    var layoutUrl = res.PublishingPageLayout.Url;
                                    layoutUrl = '/_catalogs' + layoutUrl.split('/_catalogs')[1];
                                    layoutUrl = layoutUrl.split('?')[0].toLowerCase();
                                    contentLinks.push(decodeURIComponent(layoutUrl));
                                }
                            })];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        endpoint = this.webUrl + "_api/web/getFileByServerRelativeUrl('" + location.pathname + "')/" +
                            "getLimitedWebPartManager(scope=1)/webparts?$select=WebPart/Properties/ContentLink&$expand=WebPart/Properties";
                        return [4, fetch(endpoint, this.fetchOptions)
                                .then(function (r) { return r.json(); })
                                .then(function (_a) {
                                var d = _a.d;
                                contentLinks = contentLinks.concat(d.results
                                    .filter(function (w) { return w.WebPart.Properties.ContentLink; })
                                    .map(function (w) {
                                    return w.WebPart.Properties.ContentLink.split('?')[0].toLowerCase();
                                }));
                            })];
                    case 4:
                        _a.sent();
                        return [2, contentLinks];
                }
            });
        }); };
        this.settings = __assign({}, settings, { protocol: settings.protocol || location.protocol.replace(':', ''), host: settings.host || 'localhost', port: settings.port || 3000 });
        this.devBaseUrl = (this.settings.protocol + "://" + this.settings.host + ":" + this.settings.port)
            .replace(':80', '').replace(':443', '');
        this.webUrl = (_spPageContextInfo.webServerRelativeUrl + '/').replace(/\/\//g, '/');
    }
    return LiveReloadClient;
}());
exports.LiveReloadClient = LiveReloadClient;
ExecuteOrDelayUntilBodyLoaded(function () {
    var settings = '##settings#';
    if (typeof settings === 'string') {
        settings = {};
    }
    new LiveReloadClient(settings).init();
});
